Attribute VB_Name = "Inicializacion"
Option Explicit

'/////////////////////////////////////////////////////////////////////////
'Constantes/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////

Public Const cero As Long = 0           '\
Public Const uno As Long = 1            ' \
Public Const dos As Long = 2            '  |
Public Const tres As Long = 3           '  |
Public Const cuatro As Long = 4         '  |
                                        '  |
Public Const cinco As Long = 5          '  |
Public Const seis As Long = 6           '  |
Public Const siete As Long = 7          '  |
Public Const ocho As Long = 8           '  |
Public Const nueve As Long = 9          '  |
                                        '   \
Public Const diez As Long = 10          '    \
Public Const peon As Long = 10          '     |  ---------------------------------------------------------------------------
Public Const caballo As Long = 30       '      > Se usan constantes en vez de literales pues hacen el proceso ms rpido  |
Public Const alfil As Long = 32         '     |  ---------------------------------------------------------------------------
                                        '    /
Public Const torre As Long = 50         '   /
Public Const reina As Long = 90         '  |
Public Const reyn As Long = 15000       '  |
Public Const reyb As Long = 10000       '  |
                                        '  |
Public Const cas_blanca As String = "b" '  |
Public Const cas_negra As String = "n"  ' /
Public Const infinito As Long = 30000   '/

'/////////////////////////////////////////////////////////////////////////
'Variables/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public casilla(-uno To diez, -uno To diez) As Long      'Tablero actual
Public casilla_me(-uno To diez, -uno To diez) As Long   'Guarda el mejor movimiento encontrado (so far)
Public casilla_au(-uno To diez, -uno To diez) As Long   'Se usa para operaciones secundarias (variable auxiliar)

Public casilla_n1(-uno To diez, -uno To diez) As Long   'Primeros movimientos negros
Public casilla_b1(-uno To diez, -uno To diez) As Long   'Primeros movimientos blancos
Public casilla_n2(-uno To diez, -uno To diez) As Long   'Segundos movimientos negros
Public casilla_b2(-uno To diez, -uno To diez) As Long   'Segundos movimientos blancos
Public casilla_n3(-uno To diez, -uno To diez) As Long   'Terceros movimientos negros
Public casilla_b3(-uno To diez, -uno To diez) As Long   'Terceros movimientos blancos

Public permitido(-uno To diez, -uno To diez) As Long    'Casillas permitidas de las blancas
Public permitido2(-uno To diez, -uno To diez) As Long   'Casillas permitidas de las negras
Public n1(200, -uno To diez, -uno To diez) As Long      'Primeros movimientos de las negras (para ordenarlos)
Public b1(200, -uno To diez, -uno To diez) As Long      'Primeros movimientos de las blancas (para ordenarlos)
Public juego(300, -uno To diez, -uno To diez) As Long   'Guarda todos los movimietnos del partido
Public color_casilla(63) As String                      'Color de cada casilla (color de fondo)

Public cont_n1 As Long      'Contador para guardar temporalmente las jugadas negras
Public cont_b1 As Long      'Contador para guardar temporalmente las jugadas blancas
Public valor_ini As Single  'Valor del tablero antes de hacer un movimiento (la comp)

Public max1 As Single       '----
Public max2 As Single       '-------
Public max3 As Single       '---------- Variables que indican los valores
Public min1 As Single       '---------- de cada nivel del arbol (min-blancas  max-negras)
Public min2 As Single       '-------
Public min3 As Single       '----

Public xrn As Single        'Coordenadas del rey negro
Public yrn As Single        'Coordenadas del rey negro
Public xrb As Single        'Coordenadas del rey blanco
Public yrb As Single        'Coordenadas del rey blanco

Public aviso As Boolean     'Para la busqueda en un mismo nivel pues ya no vale la pena seguir buscando
Public jugada As Single     'Numero de movimiento del partido
Public estado As Long       'Indica las etapas del juego  (1-7)
Public enrr_b As Long       '1 si el enrroque es permitido   0 si no.

Public ti_co As Double      'Acumulado del tiempo que la computadora ha estado pensando
Public tiempo As Double     'Inicializa el tiempo que se tarda la comp. en pensar
Public per As Boolean       'Indica si la llamada a gen_mov #4 es para ver las casillas permitidas
Public blancas As Long      'Numero de fichas blancas que quedan en el tablero
Public negras As Long       'Numero de fichas negras que quedan en el tablero

'/////////////////////////////////////////////////////////////////////////
'Inicializa las casillas con su contenido original
'/////////////////////////////////////////////////////////////////////////
Public Sub inicio_cotenido()
Dim x As Long, y As Long
 
 For y = -uno To diez
  For x = -uno To diez
   casilla_me(x, y) = dos
   casilla_n1(x, y) = dos
   casilla_n2(x, y) = dos
   casilla_n3(x, y) = dos
   casilla_b1(x, y) = dos
   casilla_b2(x, y) = dos
   casilla_b3(x, y) = dos
   casilla_au(x, y) = dos
   casilla(x, y) = dos
  Next x
 Next y
 
 For y = uno To ocho
  For x = uno To ocho
   casilla(x, y) = cero
  Next x
 Next y
 
 For x = uno To ocho
  casilla(x, dos) = -diez
  casilla(x, siete) = diez
 Next x
 
 casilla(uno, uno) = -torre
 casilla(dos, uno) = -caballo
 casilla(tres, uno) = -alfil
 casilla(cuatro, uno) = -reina
 casilla(seis, uno) = -alfil
 casilla(siete, uno) = -caballo
 casilla(ocho, uno) = -torre
 casilla(cinco, uno) = -reyb
 
 casilla(uno, ocho) = torre
 casilla(dos, ocho) = caballo
 casilla(tres, ocho) = alfil
 casilla(cuatro, ocho) = reina
 casilla(seis, ocho) = alfil
 casilla(siete, ocho) = caballo
 casilla(ocho, ocho) = torre
 casilla(cinco, ocho) = reyn

End Sub

'/////////////////////////////////////////////////////////////////////////
'Inicializa los colores y estados de las casillas
'/////////////////////////////////////////////////////////////////////////
Public Sub ini_casillas()
Dim x As Long
 
 color_casilla(uno) = cas_negra:    color_casilla(dos) = cas_blanca:    color_casilla(tres) = cas_negra:  color_casilla(cuatro) = cas_blanca
 color_casilla(cinco) = cas_negra:  color_casilla(seis) = cas_blanca:   color_casilla(siete) = cas_negra: color_casilla(ocho) = cas_negra
 color_casilla(nueve) = cas_blanca: color_casilla(diez) = cas_negra:    color_casilla(11) = cas_blanca:   color_casilla(12) = cas_negra
 color_casilla(13) = cas_blanca:    color_casilla(14) = cas_negra:      color_casilla(15) = cas_blanca:   color_casilla(16) = cas_blanca
 color_casilla(17) = cas_negra:     color_casilla(18) = cas_blanca:     color_casilla(19) = cas_negra:    color_casilla(20) = cas_blanca
 color_casilla(21) = cas_negra:     color_casilla(22) = cas_blanca:     color_casilla(23) = cas_negra:    color_casilla(24) = cas_negra
 color_casilla(25) = cas_blanca:    color_casilla(26) = cas_negra:      color_casilla(27) = cas_blanca:   color_casilla(28) = cas_negra
 color_casilla(29) = cas_blanca:    color_casilla(caballo) = cas_negra: color_casilla(31) = cas_blanca:   color_casilla(alfil) = cas_blanca
 
 color_casilla(33) = cas_negra:     color_casilla(34) = cas_blanca:     color_casilla(35) = cas_negra:    color_casilla(36) = cas_blanca
 color_casilla(37) = cas_negra:     color_casilla(38) = cas_blanca:     color_casilla(39) = cas_negra:    color_casilla(40) = cas_negra
 color_casilla(41) = cas_blanca:    color_casilla(42) = cas_negra:      color_casilla(43) = cas_blanca:   color_casilla(44) = cas_negra
 color_casilla(45) = cas_blanca:    color_casilla(46) = cas_negra:      color_casilla(47) = cas_blanca:   color_casilla(48) = cas_blanca
 color_casilla(49) = cas_negra:     color_casilla(torre) = cas_blanca:  color_casilla(51) = cas_negra:    color_casilla(52) = cas_blanca
 color_casilla(53) = cas_negra:     color_casilla(54) = cas_blanca:     color_casilla(55) = cas_negra:    color_casilla(56) = cas_negra
 color_casilla(57) = cas_blanca:    color_casilla(58) = cas_negra:      color_casilla(59) = cas_blanca:   color_casilla(60) = cas_negra
 color_casilla(61) = cas_blanca:    color_casilla(62) = cas_negra:      color_casilla(63) = cas_blanca:   color_casilla(0) = cas_blanca
 
 For x = cero To 63
  tablero.c(x).Visible = True
  tablero.c(x).BorderStyle = uno
 Next x

End Sub

'/////////////////////////////////////////////////////////////////////////
'Inicializa los campos de la forma tablero/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Sub ini_forma()
 
 tablero.historia.Value = 0
 tablero.historia.Max = cero
 tablero.lbl_jugada.Caption = "0"
 tablero.boardsu.Value = cero
 tablero.Progreso.Value = cero

End Sub

'/////////////////////////////////////////////////////////////////////////
'Inicializa las variables/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Sub ini_variables(): Dim x As Long, y As Long
 
 jugada = cero
 For y = -uno To diez
  For x = -uno To diez
   juego(jugada, x, y) = casilla(x, y)
  Next x
 Next y
 
 ti_co = 0
 enrr_b = 0
 per = False
 tablero.difficult.Value = True
 tablero.easy.Value = False
 tablero.tiempoco.Caption = 0
 tablero.tiempous.Caption = 0
 
End Sub

'/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////

